module Skel_poser

@opened = 0

	def Skel_poser.stop
		instances = get_instances
		instances.each do | i |
			if i.definition.name == "Quin"
				i.explode
			else
				i.erase!
			end
		end
	end

	def Skel_poser.run_frames(time,lframe)	
		keyframes = {}
		model = Sketchup.active_model
		d = model.attribute_dictionaries['kframes']
		d.each_pair do | key,value |
			a =  1
			new_value = []
			value.each do| v |
				if !v
					v = [[1,0,0],0]
				end
				v << time * a
				a += 1
				new_value << v
			end
			keyframes[key] = new_value
		end
		#p keyframes
		return keyframes
	end

	def Skel_poser.animate(time,lframe)
		root = create_tree
		instances = get_instances
		instances.each do | i |
			i.hidden = true
		end
		keyframes = Skel_poser.run_frames(time,@lframe)	
		@skel_name = "Quin"
		sk = create_skeleton root, keyframes, @skel_name
		sk.animate
	end	

	def Skel_poser.revert_master
		model = Sketchup.active_model
		ents = model.entities
		layers = model.layers
		instances = ents.select{|e| e.typename == "ComponentInstance"}
		instances.each do | i |
			if i.layer.name == "master"
				ni = ents.add_instance(i.definition,i.transformation)
				ni.name = i.name
			else
				i.erase!
			end
		end
	end	

	def Skel_poser.animate_data
		Skel_poser.revert_master
		frames = (0..@lframe).to_a
		frames = frames.join("|")
		#prompts = ["Start","Finish","Timing"]
		prompts = ["Time"]
		#defaults = [0,@lframe,@ltime]
		defaults = [@ltime]
		#list = [frames,frames]
		input = UI.inputbox prompts, defaults, "Animate"
		time = input[0]
		@ltime = time
		Skel_poser.animate(time,@lframe)
	end	

	def Skel_poser.new
		@lframe += 1
		if @dir == "+ axis"
			@dir = "+ axis"
		else
			@dir = "- axis"
		end
		pose
	end	
	
	def Skel_poser.pose
		prompts = ["Axis","Direction","Degrees"]
		defaults = [@lvector,@dir,@langle]
		list = ["Red|Green|Blue","+ axis|- axis"]
		input = UI.inputbox prompts, defaults, list, "Keyframe " + @lframe.to_s
			
		if input[1] == "+ axis"
			@dir = "- axis"
			dir = 1
		else
			@dir = "+ axis"
			dir = -1
		end
		vector = [0,0,0]
		if input[0] == "Red"
			vector [0] = 1
		end
		if input[0] == "Green"
			vector [1] = 1
		end
		if input[0] == "Blue"
			vector [2] = 1
		end
		@lvector = input[0]
		angle = input[2].degrees * dir
		
		@langle = input[2]
		time = 0.1
		
		sel = Sketchup.active_model.selection[0]
		name = sel.name

		exists = 0

		if @dict.keys
			@dict.each_key do |key|
				if key == name
					exists = 1
				end
			end
		end
		model = Sketchup.active_model
		#Timing is added by run
		array = [vector,angle]
		if exists == 0
			#starts a new hash key and new blank value array
			model.set_attribute('kframes',name,[])
		end
			
		#adds or replaces a keyframe array
		extg = model.get_attribute('kframes',name)
		
		#if the array exists at lframe position add the new rotation to the old
		
		if(extg[@lframe])
			extg[@lframe][1] += array[1]
		else
			extg[@lframe] = array
		end
		model.set_attribute('kframes',name,extg)
	
		root = create_tree
		instances = get_instances
		instances.each do | i |
			i.hidden = true
		end
		time = 0.1
		keyframes = {}
		keyframes[name] = [[vector,angle,time]]
		@skel_name = "Quin"
		sk = create_skeleton root, keyframes, @skel_name
		sk.animate
	end
	
	def Skel_poser.last_frame
		#model dictionary
		@dict = Sketchup.active_model.attribute_dictionary "kframes",true
		l = 0
		@dict.values.each do | v |
			if v.length > l
				l = v.length
			end
		end
		return l
	end	

	def Skel_poser.set_master
		model = Sketchup.active_model
		ents = model.entities
		layers = model.layers
		if !layers["master"]
			layers.add "master"
			layers["master"].visible = false
			instances = ents.select{|e| e.typename == "ComponentInstance"}
			instances.each do | i |
				ni = ents.add_instance(i.definition,i.transformation)
				ni.name = i.name
				ni.layer = "master"
			end
		end
	end	
	
	def Skel_poser.open (act)
		if @opened == 0
			@opened = 1
			Skel_poser.set_master
			#opening defaults
			@fno = 0
			@dir = "+ axis"
			@lvector = "Red"
			@langle = 45
			@ltime = 2
			#this is needed in case a file is opened that might have keyframes
			@lframe = Skel_poser.last_frame
			if @lframe != 0
				@lframe -= 1
			end
		end
		eval('Skel_poser.'+act)
	end	

	def Skel_poser.bounds(ents,ind)
		arr = []
		ents.each do | i |
				c = i.bounds.center.to_a
				arr << {'center'=> c, 'comp' => i}
		end
		return arr.sort_by { |s|s["center"][ind]}
	end	
	
	def Skel_poser.auto_name
		named = Sketchup.active_model.get_attribute("config","named")
		p named
		defs = Sketchup.active_model.definitions
		defs.purge_unused
		ents = Sketchup.active_model.entities
		instances = ents.select{|e| e.typename == "ComponentInstance" || e.typename == "Group"}

		if instances.length == 1
			instances[0].explode
			instances = ents.select{|e| e.typename == "ComponentInstance"}
		end

		#Which side
		sides = bounds(instances,0)
		lefts = []
		rights = []
		a = 0
		sides.each do |s|
			if s["comp"].definition.name === "body"
				s["comp"].name = "body"
			elsif a < sides.length/2
				rights << s["comp"]
			else 
				lefts << s["comp"]
			end
			a += 1
		end
		
		both = [[rights,"Right"],[lefts,"Left"]]
		both.each do |b|
			bs = bounds(b[0],2)
			x = 0
			limbs = ["leg","arm"]
			parts = ["lower","upper"]
			part = parts[0]
			bs.each do |d|
				if x < bs.length/2
					limb = limbs[0]
				else 
					limb = limbs[1]
				end
				d["comp"].name = [b[1],limb,part].join("_")
				p d["comp"].name
				if part == parts[0]
					part = parts[1]
				else
					part = parts[0]
				end
				x += 1
			end
			@named = 1
		end
	end
	
	def Skel_poser.joint_comp
		comp = Sketchup.active_model.definitions.add "joint"
		path = comp.entities.add_circle [0,0,0], [0,0,1], 15.mm
		circle = comp.entities.add_circle [0,0,0], [0,1,0], 15.mm
		circle_face = comp.entities.add_face circle
		circle_face.followme path
		return comp
	end	
	
	
	def Skel_poser.auto_joints
		UI.messagebox "Under construction"

=begin
		ents = Sketchup.active_model.entities
		instances = get_instances
		comp = Skel_poser.joint_comp
		instances.each do | i |
			point = i.bounds.center.to_a
			depth = i. bounds.depth
			height = i.bounds.height
			point[2] += (depth - height)
			d = i.definition
			j = d.entities.add_instance(comp,point)
			j.name = i.name

		end
=end
	
	
	
	end
end

include Skel
include Skel_tree

filename = "skel_ui.rb"

if !file_loaded?(filename)
	# Add to the context menu
	UI.add_context_menu_handler do |menu|
		menu.add_separator
		menu.add_item('Pose') { Skel_poser.open('pose') }
		menu.add_item('New frame'){Skel_poser.open('new')}
	end

    menu = UI.menu('View').add_submenu('Skel_animation')
	menu.add_item('Run'){Skel_poser.open('animate_data')}
	menu.add_item('Auto name'){Skel_poser.auto_name}
	menu.add_item('Auto joints'){Skel_poser.auto_joints}

	file_loaded(filename)

end

